import processing.serial.*; //used for communication from the arduino
String buff = "";
char header[] = {'A', 'B'}; //We use the data transmission protocol in which we use use headers to seperate values from the Arduino
int value[] = new int[2]; //we store the values in here, two values are being sent: both values from the light sensors
int NEWLINE = 10;

float temp; //sepereate variables for the potentiometers and button, this makes it easier to use them 
int rightSensor;

Serial port; //the port the Arduino is in connected

void setup() {
  size(700, 700);
  background(200);
  println("Available serial ports:"); //we look for available ports
  for (int i = 0; i<Serial.list ().length; i++) { 
    print("[" + i + "] ");
    println(Serial.list()[i]);
  }
  port = new Serial(this, Serial.list()[0], 9600); //this is the port the arduino is on
  frameRate(30);  // delay of 50 ms, 20Hz update
}

void draw() {
  background(200);
  while (port.available() > 0) {
    serialEvent(port.read()); // we read the data from the arduino
  }
  temp = value[0]; //easier to work with
  rightSensor = value[1];
  println(value[1]);
  
  //temperature sensor
  temp = (float)temp / 1024;
  temp = ((temp * 5) - 0.5) * 100; //calculate in celsius
  String temperature = nf(temp,0,1);
  textSize(50);
  text("Temperature: " + temperature + " C",40,100);
}

void serialEvent(int serial) 
{ 
  try {    // try-catch because of transmission errors
    if (serial != NEWLINE) { 
      buff += char(serial);
    } else {
      // The first character tells us which axis this value is for
      char c = buff.charAt(0);
      // Remove it from the string
      buff = buff.substring(1);
      // Discard the carriage return at the end of the buffer
      buff = buff.substring(0, buff.length()-1);
      // Parse the String into an integer
      for (int z=0; z<2; z++) {
        if (c == header[z]) {
          value[z] = Integer.parseInt(buff);
        }
      }
      buff = "";         // Clear the value of "buff"
    }
  }
  catch(Exception e) {
    println("no valid data");
  }
}
